Distribution:	CCux
Packager:	Christian Metzen <metzench@ccux-linux.de>

Summary:	An ImageMagick fork, offering faster image generation and better quality
Name:		GraphicsMagick
Version:	1.3.12
Release:	1
License:	MIT
Group:		Multimedia/Graphics
Url:		http://www.graphicsmagick.org/
Buildroot:	%{_tmppath}/%{name}-%{version}-root
BuildArch:	i686

# Sources
Source0:	http://download.sourceforge.net/graphicsmagick/GraphicsMagick-%{version}.tar.bz2

# Patches
Patch1:		GraphicsMagick-perl.patch
Patch2:		GraphicsMagick-1.1.10-gcc43.patch

#Automatically resolved build dependencies
BuildRequires: bzip2-devel
BuildRequires: freetype-devel
BuildRequires: ghostscript-devel
BuildRequires: glibc-devel
BuildRequires: jasper-devel
BuildRequires: jbigkit-devel
BuildRequires: lcms-devel
BuildRequires: libfpx-devel
BuildRequires: libICE-devel
BuildRequires: libjpeg-devel
BuildRequires: libpng-devel
BuildRequires: libSM-devel
BuildRequires: libstdc++-devel
BuildRequires: libtiff-devel
BuildRequires: libwmf-devel
BuildRequires: libX11-devel
BuildRequires: libXext-devel
BuildRequires: libxml2-devel
BuildRequires: zlib-devel
BuildRequires: librsvg-devel

%description
GraphicsMagick is a comprehensive image processing package which is initially
based on ImageMagick 5.5.2, but which has undergone significant re-work by
the GraphicsMagick Group to significantly improve the quality and performance
of the software.

%package	devel
Summary:	Static libraries and header files for GraphicsMagick app development
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	ghostscript-devel, bzip2-devel, libtiff-devel, libjpeg-devel
Requires:	lcms-devel, pkgconfig, libX11-devel, libXext-devel, libXt-devel

%description	devel
GraphicsMagick-devel contains the static libraries and header files you'll
need to develop GraphicsMagick applications. GraphicsMagick is an image
manipulation program.

If you want to create applications that will use GraphicsMagick code or
APIs, you need to install GraphicsMagick-devel as well as GraphicsMagick.
You do not need to install it if you just want to use GraphicsMagick,
however.

%package	perl
Summary:	GraphicsMagick perl bindings
Group:		System/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description	perl
Perl bindings to GraphicsMagick.

Install GraphicsMagick-perl if you want to use any perl scripts that use
GraphicsMagick.

%package	c++
Summary:	GraphicsMagick Magick++ library (C++ bindings)
Group:		System/Libraries
Requires:	%{name} = %{version}-%{release}

%description	c++
This package contains the GraphicsMagick++ library, a C++ binding to the 
GraphicsMagick graphics manipulation library.

Install GraphicsMagick-c++ if you want to use any applications that use 
GraphicsMagick++.

%package	c++-devel
Summary:	C++ bindings for the GraphicsMagick library
Group:		Development/Libraries
Requires:	%{name}-c++ = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}

%description	c++-devel
GraphicsMagick-devel contains the static libraries and header files you'll
need to develop GraphicsMagick applications using the Magick++ C++ bindings.
GraphicsMagick is an image manipulation program.

If you want to create applications that will use Magick++ code
or APIs, you'll need to install GraphicsMagick-c++-devel, ImageMagick-devel and
GraphicsMagick.
You don't need to install it if you just want to use GraphicsMagick, or if you
want to develop/compile applications using the GraphicsMagick C interface,
however.

%prep
%setup -q
#%patch1 -p 1 -b .perl
#%patch2 -p1 -b .gcc43

iconv -f iso-8859-2 -t utf8 < ChangeLog > ChangeLog.utf8
mv -f ChangeLog.utf8 ChangeLog

%build

# No configure options in the moment:
# --with-lzw
# --with-rsvg

%configure \
--enable-shared \
--with-modules \
--with-x \
--with-magick_plus_plus \
--with-gslib \
--with-wmf \
--with-lcms \
--with-xml \
--with-windows-font-dir=%{_datadir}/fonts/default/TrueType \
--with-perl \
--with-perl-options="PERL_INSTALL_ROOT=%{buildroot} CC='%__cc -L$PWD/magick/.libs' LDDLFLAGS='-shared -L$PWD/magick/.libs'" \
--with-threads \
--disable-openmp \
--without-dps
make %{?_smp_mflags}

%install
rm -rf %{buildroot}

make install DESTDIR=%{buildroot}

# perlmagick: fix perl path of demo files
%{__perl} -MExtUtils::MakeMaker -e 'MY->fixin(@ARGV)' PerlMagick/demo/*.pl

find %{buildroot} -name "*.bs" |xargs rm -f
find %{buildroot} -name ".packlist" |xargs rm -f
find %{buildroot} -name "perllocal.pod" |xargs rm -f

#chmod 755 %{buildroot}%_libdir/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Graphics/Magick/Magick.so

# perlmagick: build files list
echo "%defattr(-,root,root)" > perl-pkg-files
find %{buildroot}/%{_libdir}/perl* -type f -print \
    | sed "s@^%{buildroot}@@g" > perl-pkg-files 
find %{buildroot}%{perl_vendorarch} -type d -print \
    | sed "s@^%{buildroot}@%dir @g" \
    | grep -v '^%dir %{perl_vendorarch}$' \
    | grep -v '/auto$' >> perl-pkg-files 
if [ -z perl-pkg-files ] ; then
    echo "ERROR: EMPTY FILE LIST"
    exit -1
fi

#rm -rf %{buildroot}%{_datadir}/GraphicsMagick
# Keep config
#rm -rf %{buildroot}%{_datadir}/%{name}-%{version}/[a-b,d-z,A-Z]*
rm -rf %{buildroot}%{_libdir}/libltdl.*
rm -f  %{buildroot}%{_libdir}/GraphicsMagick-*/modules*/*/*.a
rm -f  %{buildroot}%{_libdir}/*.{a,la}

%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig

%post c++ -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%postun c++ -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc Copyright.txt
%doc README.txt
%doc %{_datadir}/doc/%{name}/
%attr(755,root,root) %{_libdir}/libGraphicsMagick.so.*
%attr(755,root,root) %{_libdir}/libGraphicsMagickWand.so.*
%{_bindir}/[a-z]*
%{_libdir}/GraphicsMagick*
%{_datadir}/GraphicsMagick*
%{_mandir}/man[145]/[a-z]*

%files devel
%defattr(-,root,root,-)
%{_bindir}/GraphicsMagick-config
%{_bindir}/GraphicsMagickWand-config
%{_libdir}/libGraphicsMagick.so
%{_libdir}/libGraphicsMagickWand.so
%{_libdir}/pkgconfig/GraphicsMagick.pc
%{_libdir}/pkgconfig/GraphicsMagickWand.pc
%{_includedir}/GraphicsMagick/
%{_mandir}/man1/GraphicsMagick-config.*
%{_mandir}/man1/GraphicsMagickWand-config.*

%files c++
%defattr(-,root,root,-)
%{_libdir}/libGraphicsMagick++.so.*

%files c++-devel
%defattr(-,root,root,-)
%{_bindir}/GraphicsMagick++-config
%{_includedir}/GraphicsMagick/Magick++
%{_includedir}/GraphicsMagick/Magick++.h
%{_libdir}/libGraphicsMagick++.so
%{_libdir}/pkgconfig/GraphicsMagick++.pc
%{_mandir}/man1/GraphicsMagick++-config.*

%files perl -f perl-pkg-files
%defattr(-,root,root,-)
#%{_mandir}/man3/*
%doc PerlMagick/demo/ PerlMagick/Changelog PerlMagick/README.txt

%changelog
* Tue Sep 21 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.3.12-1
- Version update
* Wed Nov 25 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.3.7-1
- Version update
* Thu Aug 13 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.3.4-2
- rebuilt against libjpeg 7
- kept GraphicsMagick 1.3.4 as 1.3.6 won`t compile properly atm
* Fri Jan 16 2009 Christian Wasem <wasem@ccux-linux.de> 1.3.4-1
- Version update, disabled OpenMP support (XShearImage won't build)
* Mon Oct 20 2008 Christian Metzen <metzench@ccux-linux.de> 1.1.14-2
- rebuild with find_dependencies
* Fri Oct 17 2008 Christian Metzen <metzench@ccux-linux.de> 1.1.14-1
- Initial release
